package sim.lib.others;

import java.awt.*;
import java.awt.event.*;

import sim.util.SimSeparator;

public class TextBoxProperties extends Container implements ActionListener {

	private TextField editText = new TextField(10);
	private Label text = new Label("Text");

	public TextBoxProperties(String initText) {
		super();
		this.setLayout(new GridBagLayout());

		this.editText.setText(initText);

		this.editText.addActionListener(this);

		// text
		Panel big = new Panel(new BorderLayout(0, 15));

		Panel p = new Panel(new BorderLayout());
		p.add(this.text, BorderLayout.WEST);
		p.add(new SimSeparator(), BorderLayout.CENTER);
		big.add(p, BorderLayout.NORTH);

		p = new Panel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();

		c.gridy = 0;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.anchor = GridBagConstraints.WEST;

		c.weighty = 0;

		c.fill = GridBagConstraints.HORIZONTAL;
		c.weightx = 1;
		c.gridx = 0;

		p.add(this.editText, c);
		big.add(p, BorderLayout.CENTER);

		c.gridx = 0;
		c.insets = new Insets(0, 0, 15, 0);
		c.weightx = 1;
		c.fill = GridBagConstraints.HORIZONTAL;

		this.add(big, c);
	}

	public void addNotify() {
		super.addNotify();
		this.setSize(290, this.text.getPreferredSize().height * 7);
	}

	public void actionPerformed(ActionEvent e) {
		TextField source = (TextField) e.getSource();
	}
	
	public String getText() {
		return this.editText.getText();
	}

	public Dimension getPreferredSize() {
		return this.getSize();
	}

	public Dimension getMinimumSize() {
		return this.getSize();
	}

	public Dimension getMaximumSize() {
		return this.getSize();
	}
}
